/* ̧قDoxygenpɏĂ܂B */
/*! \file *********************************************************************
 *
 * \brief LED쓮`Ԑݒͯ ̧
 *
 *	̧قAtmel LED쓮߂𐧌䂷邽߂Ɋe̪eAVR MCU
 *	p̺ނ𐶐悤ײ؂\ݒ肷邽߂̒`܂݂܂B
 *	ײ؂݈͌ȉ̲̪߂x܂B
 *		1. XMEGA	: TWI̪ (ATxmega32A4Ō)
 *		2. MEGAAVR	: TWI̪ (ATmega2560Ō)
 *		3. TINYAVR	: USIłSPI ((MISOԂ33Rڑ)ATtiny25Ō)
 *		4. TINYAVR	: SPI ((MISOԂ33Rڑ)ATtiny40Ō)
 *
 *	ײނ͖wǂ̊֐Pɐs̺ނŊ֐Ăяo̊Ԑڕׂސ\
 *	炷߁A傫⑬xdvȺނɑ΂ĈӐ}܂Bײނtiny
 *	 SPI呕uPʕŎn߂邽߂̑fƎ̖ړIӐ}܂B
 *
 *	傫⑬xdvȺނɂẮA֐ĂяosɂȂ̉p
 *	Ɋ֐e𒼐ڕʂ邱Ƃ܂B
 *
 *
 * $Date: 2011-10-10 13:03:43 $  \n
 *
 * 쌠 (c) 2008, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *****************************************************************************/

#ifndef DEVICE_H_
#define DEVICE_H_

#include "avr_compiler.h"
//*****************************************************************************
/*! \brief gp҂͂޲`邱Ƃł܂B(ATXMEGA,MEGAAVR,TINYAVR) */
#define TINYAVR

/*! \brief SPI,TWI,SPI_USI̲̪`ĂB */
#define SPI

//*****************************************************************************
/*! \brief AVRHzłCPUۯBްڰĐݒƒxɎgp܂B */
#define F_CPU			20000000

//*****************************************************************************
/*! \brief ŏ]uڽ`ĂB */
#define SLAVE_ADDRESS	0x5D

//*****************************************************************************
//**************************** ATXMEGA TWIҰ ******************************
#if defined(ATXMEGA) && defined(TWI)
	#include "atxmega_twi_driver.h"

	/*! \brief ڽ ޲Ăڼ޽ ڽđ󂳂őүޗʁBzǂ/֐gpAҰNUM_BYTES𒴂܂B */
	#define NUM_BYTES	16

	/*! gpTWI߰ */
	#define TWI_PORT	TWIC

	/*! TWI呕u荞 */ 
	#define TWI_INT_VECTOR TWIC_TWIM_vect

	/*! ްڰ (100kHz) */
	#define BAUDRATE	100000

//*****************************************************************************

//****************************MEGAAVR TWIҰ *******************************
#elif defined(MEGAAVR) && defined(TWI)
	#include "atmega_twi_driver.h"

	/*! \brief ڽ ޲Ăڼ޽ ڽđ󂳂őүޗʁBzǂ/֐gpAҰNUM_BYTES𒴂܂B */
	#define NUM_BYTES	16

	// ްڰ Ұ
	// SCLg(CPU_CLOCK FREQ)/(16+2*TWBR*(4^TWPS))ƂČvZ܂B
	// gp҂CPUۯƖ]ގgɉĈȉ̒lTdɑI΂ȂĂ͂Ȃ܂B
	// SCLg͖wǂ̎gp҂Ɋւ100kHzƓ܂͂ȉłׂłB

	#define TWI_TWBR	0x20			//!< TWIޯđxڼ޽ݒB8MHzCPUۯ100kHzSCLB̒l̐ݒ̏ڍ׏ɂĂ͉pLqB
	#define TWI_TWPS	0x00			//!< ײނ͑Ou=00Ɖ

//*****************************************************************************

//*************************TINYAVR SPI VIA USIҰ **************************

// dv
// tinyAVRAtmel LED쓮߂MISOԂ33Rڑ邱ƂYȂłB

#elif defined(TINYAVR) && defined(SPI_USI)
	#include "tiny_avr_spi_via_usi_driver.h"

	/* ATtiny25pUSI߰Ă݂̒` */
	#define USI_OUT_REG	PORTB			//!< USI߰ďoڼ޽
	#define USI_IN_REG	PINB			//!< USI߰ēڼ޽
	#define USI_DIR_REG	DDRB			//!< USI߰ĕڼ޽
	#define USI_CLOCK_PIN		PB2		//!< USIۯo
	#define USI_DATAIN_PIN		PB0		//!< USIް
	#define USI_DATAOUT_PIN		PB1		//!< USIްo
	#define CSB_PIN         	PB4		//!< Atmel LED쓮CSBڑ

	/* x`Ԑݒ:
	 * ޯ/b = CPUSPEED / PRESCALER / (COMPAREVALUE+1) / 2
	 * ő = CPUSPEED / 64
	 */
	#define TC0_PRESCALER_VALUE	1		//!< 1,8,64,256܂1024łȂ΂Ȃ܂B
	#define TC0_COMPARE_VALUE	31		//!< 0`255łȂ΂Ȃ܂BOu=CLK/1ōŏ31

//*****************************************************************************

//**************************** TINYAVR SPIҰ ******************************

// dv
// tinyAVRAtmel LED쓮߂MISOԂ33Rڑ邱ƂYȂłB

#elif defined(TINYAVR) && defined(SPI)
    #include "tiny_avr_spi_driver.h"
	/****************** SCKgݒ *********************
	SCK = (F_CPU/SPI_CLK_DIVIDER)*(2^SPI_CLK_DOUBLE)
	̗łF_CPU(Max)/2A6MHzɐݒ肳܂B
	*******************************************************/
	/*! SPR[1:0]ɂĒ`SCKݒłB */
	#define SPI_CLK_DIVIDER		4		//!< 4,16,64,128łȂ΂Ȃ܂B

	/*! ͐ݒ(1)SCK{ɂSPI2XޯĐݒłB */
	#define SPI_CLK_DOUBLE		1		//!< 1܂0łȂ΂Ȃ܂B

	#define SPI_DIR_REG			DDRC	//!< SPI߰ĕڼ޽
	#define SPI_PORT			PORTC	//!< SPI߰ďoڼ޽
	#define SPI_SCK				PC1		//!< SPIۯo
	#define SPI_MISO			PC2		//!< SPIް
	#define SPI_MOSI			PC4		//!< SPIްo
	#define SPI_SS				PC0		//!< Atmel LED쓮CSBڑ

//*****************************************************************************

#endif

#endif /* DEVICE_H_ */
