/* ̧قDoxygenpɏĂ܂B */
/*! \file *********************************************************************
 *
 * \brief ̧قAVR\ɊÂނIAR Cׂ߲AVR-GCC𓮂
 *		  ϸۂ܂B
 *
 * \par 
 *		IAxׁ߲A߲אݒAx޲ɂĂreadme.html
 *		B
 *
 * \author
 *	Atmel Corporation	: http://www.atmel.com \n
 *	xEҰ			: avr@atmel.com
 *
 * $Revision: 613 $
 * $Date: 2006-04-07 14:40:07 +0200 (fr, 07 apr 2006) $  \n
 *
 * 쌠 (c) 2008, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 ******************************************************************************/

#ifndef COMPILER_AVR_H
#define COMPILER_AVR_H

#ifndef F_CPU
/*! \brief ꂪɒ`ĂȂꍇɊCPUg` */
#define F_CPU 2000000UL
#endif

#include <stdint.h>
#include <stdbool.h>
#include <stdlib.h>

/*! \brief ϸۂ͊荞݂ȉ̺ނ܂B */
#define AVR_ENTER_CRITICAL_REGION( ) uint8_t volatile saved_sreg = SREG; \
									 cli();

/*! \brief ϸۂ͊荞݂Ăы悤ɏAVR_ENTER_CRITICAL_REGION
 *		   ƋɎgpȂ΂Ȃ܂B
 */
#define AVR_LEAVE_CRITICAL_REGION( ) SREG = saved_sreg;

#if defined( __ICCAVR__ )

#include <inavr.h>
#include <ioavr.h>
#include <intrinsics.h>
#include <pgmspace.h>

#ifndef __HAS_ELPM__
#define _MEMATTR  __flash
#else /* __HAS_ELPM__ */
#define _MEMATTR  __farflash
#endif /* __HAS_ELPM__ */

/*! \brief \c us ϲەb̒xs
 *
 *  F_CPUϸۂ(Hzł)CPUۯg`萔̒`Ƒz肳܂B
 *
 *  ő\x262.14ms/HzłF_CPUłB
 *
 *  \note IARׂ߲ɑ΂ĐF_CPU1000000UL(1MHz)̔{łȂ΂Ȃ܂B
 */
#define delay_us( us )   ( __delay_cycles( ( F_CPU / 1000000UL ) * ( us ) ) )

/*! \brief ۾x
 *
 *  IARׂ߲ɈĊ荞ݏٰݐ錾ͯ ْ̧ۉ
 *  xBٰ݂ISRp̌ŗL̊֐\z邾łȂA荞
 *  ̊蓖Ă̗s߁A۾̈قȂ2ق̘AłȂA
 *  (ϸےuƂĎgp꓾Ȃ#pragma̕ނ)C99 _Pragma()߂̎g
 *  pKvłB
 *
 *  \note ꂪ^ꂽԂł߁AϸۂёւȂłB
 */
#define PRAGMA(x) _Pragma( #x )
#define ISR(vec) PRAGMA( vector=vec ) __interrupt void handler_##vec(void)
#define sei( ) (__enable_interrupt( ))
#define cli( ) (__disable_interrupt( ))

/*! \brief ϸے` */
#define nop( ) (__no_operation())

/*! \brief ޯ ؾ ϸے` */
#define watchdog_reset( ) (__watchdog_reset( ))

#define INLINE PRAGMA( inline=forced ) static

#define FLASH_DECLARE(x) _MEMATTR x
#define FLASH_STRING(x) ((_MEMATTR const char *)(x))
#define FLASH_STRING_T  char const _MEMATTR *
#define FLASH_BYTE_ARRAY_T uint8_t const _MEMATTR *
#define PGM_READ_BYTE(x) *(x)
#define PGM_READ_WORD(x) *(x)

#define SHORTENUM /**/

#elif defined( __GNUC__ )

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>

/*! \brief GCCpdelay_usϸے` */
#define delay_us( us )   (_delay_us( us ))

#define INLINE static inline

/*! \brief ϸے` */
#define nop()   do { __asm__ __volatile__ ("nop"); } while (0)

#define MAIN_TASK_PROLOGUE int

#define MAIN_TASK_EPILOGUE() return -1;

#define SHORTENUM __attribute__ ((packed))

#else
#error Compiler not supported.
#endif

#endif
